'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _en = require('cacache/en');

var _en2 = _interopRequireDefault(_en);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Cache = function () {
    function Cache(options) {
        _classCallCheck(this, Cache);

        this.cachePath = _path2.default.format({
            root: options.root,
            name: options.dir
        });
    }

    _createClass(Cache, [{
        key: 'has',
        value: function has(key) {
            return _en2.default.get.info(this.cachePath, key).then(function (i) {
                return i !== null;
            });
        }
    }, {
        key: 'get',
        value: function get(key) {
            var _this = this;

            return new Promise(function (resolve) {
                return resolve(_en2.default.get.stream(_this.cachePath, key));
            });
        }
    }, {
        key: 'clear',
        value: function clear() {
            return _en2.default.rm.all(this.cachePath);
        }
    }, {
        key: 'del',
        value: function del(key) {
            return _en2.default.rm.entry(this.cachePath, key);
        }
    }, {
        key: 'set',
        value: function set(key, stream) {
            var _this2 = this;

            return new Promise(function (resolve, reject) {
                var handle = _en2.default.put.stream(_this2.cachePath, key).on('integrity', resolve).on('error', reject);
                stream.pipe(handle);
            });
        }
    }]);

    return Cache;
}();

exports.default = Cache;