'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _statement = require('./statement');

var _statement2 = _interopRequireDefault(_statement);

var _json = require('./json');

var _json2 = _interopRequireDefault(_json);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function encode(string) {
    return Buffer.from(string).toString('base64');
}

function decode(string) {
    return Buffer.from(string, 'base64').toString();
}

function pack(data) {
    return encode(JSON.stringify(data));
}

function unpack(data) {
    return JSON.parse(decode(data));
}

function unscramble(data) {
    return _json2.default.parse(decode(data));
}

exports.default = {
    pack: pack,
    unpack: unpack,
    encode: encode,
    decode: decode,
    unscramble: unscramble
};