'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = singleton;

var _stream = require('stream');

var _deepObjectDiff = require('deep-object-diff');

function singleton(data, feed) {
    var _this = this;

    if (this.isLast()) {
        return feed.close();
    }
    if (this.isFirst()) {
        var ezs = this.ezs;

        var statement = this.getParam('statement');
        var environment = this.getEnv();
        var paramaters = this.getParams();
        var savedData = Object.assign({}, data);
        var input = new _stream.PassThrough({ objectMode: true });
        var result = {};

        input.pipe(ezs(statement, paramaters, environment)).pipe(ezs.catch(function (e) {
            return e;
        })).on('error', function (e) {
            return feed.stop(e);
        }).on('data', function (chunk) {
            result = Object.assign(result, chunk);
        }).on('end', function () {
            _this.addedResult = (0, _deepObjectDiff.addedDiff)(savedData, result);
            feed.send(Object.assign(data, _this.addedResult));
        });
        input.write(data);
        return input.end();
    }
    return feed.send(Object.assign(data, this.addedResult));
}